//determine frequency of particular Dewey Decimal ranges  
void calculateDeweys()
{
  //reset global counters
  totalDeweys = 0;
  deweyCount = new int[10];
  
  //calculate number of items within particular dewey ranges 
  Transaction t;
  for (int i = 0; i < transactions.size(); i++)
  {
    t = (Transaction)transactions.get(i);
    
    //IF the item has a dewey classifcation
    //  AND it has a legitimate title
    //  AND the title begins with the currently selected letter
    //THEN calculate and store the item's dewey number.
    if (t.deweyClass.length() > 0 && t.title.length() > 0 && (t.title.charAt(0) == curKeyIdx || t.title.charAt(0) == curKeyIdx - 32))
    {
      totalDeweys++;
      float dd = float(t.deweyClass);
      
      //dewey decimals are always between 0 and 1000
      deweyCount[(int)(dd/100f)]++; 
    }
  }  
  println("dewey ranges = " + Arrays.toString(deweyCount));
  
}

public ArrayList loadTransactions()
{
  ArrayList transactions = new ArrayList();

  File[] fileArr = listFiles(dataPath(""));

  for (int fn = 0; fn < fileArr.length; fn++) 
  {
    File f = (File) fileArr[fn];    

    if (!f.getName().endsWith(".txt"))
    {
      continue;
    }

    println("loading file... \"" + f.getName() + "\"");
    String[] lines = loadStrings(f);

    for (int i = 0; i < lines.length; i++)
    {
      transactions.add(parseTransaction(lines[i])); 
    }
  }

  return transactions;
}


// This function returns all the files in a directory as an array of File objects
// This is useful if you want more info about the file
public File[] listFiles(String dir) {
  File file = new File(dir);
  if (file.isDirectory()) {
    File[] files = file.listFiles();
    return files;
  } 
  else {
    // If it's not a directory
    return null;
  }
}

//create a new transaction obejct from a comma separated line.
public Transaction parseTransaction(String line)
{
  String sections[] = split(line, ",");

  Transaction t = new Transaction();

  //store all fields
//  t.itemNumber = sections[0];
//  t.bibNumber = sections[1];
  t.ckodate = sections[0];
//  t.ckotime = sections[3];
//  t.ckidate = sections[4];
//  t.ckitime = sections[5];
//  t.collcode = sections[6];
  t.itemtype = sections[1];
//  t.barcode = sections[8];
//  t.title = sections[9];
//  t.callNumber = sections[10];
  t.deweyClass = sections[2];
  hm.put(t.itemtype, 1);
//  int numSubjects = sections.length - 12;
//  t.subjects = new String[numSubjects];
//  arraycopy(sections, 12, t.subjects, 0, numSubjects);

  return t;
}





