import processing.opengl.*;
import toxi.color.*;
import toxi.geom.*;
import toxi.math.*;

// keepers of transition state & target
float transition, transTarget; 
ArrayList transactions = null; //global List of the data
int curKeyIdx = (int) 'a';
String curKeyStr = "a";
int idx = 0;
int maxNum = 200;
int[] deweyCount = new int[10];
int totalDeweys = 0;
HashMap hm = new HashMap(); 
PFont font1; 


// use a S-Curve to achieve an ease in/out effect
InterpolateStrategy is=new SigmoidInterpolation(3);

void setup() {
  size(1280,720);
  smooth(); 
  background(255); 
  this.transactions = loadTransactions();
  font1 = loadFont("HelveticaNeue-30.vlw"); 
  textFont(font1); 
  textAlign(LEFT,CENTER); 
  Iterator i = hm.entrySet().iterator();  // Get an iterator

  while (i.hasNext()) {
  Map.Entry me = (Map.Entry)i.next();
  print(me.getKey() + " is ");
  println(me.getValue());
}
}

void draw() {
  background(255);
  float w2= width*0.5;
  float h2= height*0.5;
  translate(w2, h2);
  // update transition
  transition += (transTarget - transition) * 0.01;
  Vec2D normUp = new Vec2D(0, -1);
  // define a color container using HSV
  TColor col = TColor.newHSV(0, 1, 1);
  //beginShape();
  for(int i = 270; i < 360 + 270; i += 3.6) {
    float theta = radians(i);
    // create a polar coordinate
    Vec2D polar = new Vec2D(150,theta);
    // use theta as color hue (ensure theta is properly wrapped)
    col.setHue((polar.y / TWO_PI) % 1);
    // also use theta to manipulate line length
    float len = noise(polar.y * 4) * h2;
    // convert polar coord into cartesian space (to obtain position on a circle)
    Vec2D circ = polar.copy().toCartesian();
    // create another coord splicing the circle at the top and using theta difference as position on a line
    Vec2D linear = new Vec2D((MathUtils.THREE_HALVES_PI - polar.y) * w2 / PI + w2 - 8, h2);
    // interprete circular position as normal/direction vector 
    Vec2D dir = circ.getNormalized();
    // interpolate both position & normal based on current transition state
    circ.interpolateToSelf(linear, transition,is);
    dir.interpolateToSelf(normUp, transition,is).normalizeTo(len);
    // apply color & draw line
    stroke(col.toARGB(),200);
    strokeCap(ROUND);
    strokeWeight(4); 
    //curveVertex(circ.x + dir.x, circ.y + dir.y);
    line(circ.x, circ.y, circ.x + dir.x, circ.y + dir.y);
    fill(col.toARGB()); 
    //text("hello", circ.x + dir.x, circ.y + dir.y); 
  }
  //endShape(); 
}

void mousePressed() {
  // toggle transition target state
  transTarget=(++transTarget % 2);
}

