import java.util.*;

ArrayList transactions = null; //global List of the data
ArrayList letterEntries;

int curIdx = 0;
int maxCnt = 0;
int curKeyIdx = (int) 'a';


float angle;
float x;
float y;
float radius; 
float rad; 
float maxVal = 500; 
PFont font1;
PFont font;
int num = 0; 

void setup()
{
  size(800,800);
  background(255);
  frameRate(60); //that is, as fast as possible
  font = loadFont("HelveticaNeue-Light-29.vlw"); 
  font1 = loadFont("HelveticaNeue-Bold-12.vlw"); 
  long before = millis();
  println("about to load...");
  this.transactions = loadTransactions();
  println("loaded " + this.transactions.size() + " transactions in " + (millis() - before) + " miiliseconds.");
  letterEntries = TransactionUtils.countUniqueLetters(this.transactions);
  TransactionUtils.sortUniqueLetterCountsByLetter(letterEntries, TransactionUtils.ASCENDING);
  angle = 13.84615; 

  smooth(); 
}

void draw()
{
  num++; 
  background(0); 
  pushMatrix(); 
  translate(width/2,height/2); 
  textFont(font);
  //rotate(-PI/6); 
  for (int i = 44; i < letterEntries.size(); i++)
  {
    Map.Entry entry = (Map.Entry) letterEntries.get(i);
    //println("Character " + entry.getKey() + " appears: " + entry.getValue() + " times.");
    //entry.getKey(); 
    //entry.getValue(); 
    int k = TransactionUtils.getIntValueForEntry(letterEntries.get(i)); 
    //String letter = (String) TransactionUtils.getStringKeyForEntry(letterEntries.get(i));
    radius = map(k, 108, 3005042, 85, maxVal);  
    rad = map(k, 18918, 3005042, 25,300);  
    x = radius*cos( (i-44)*PI*(angle/180.0)); 
    y = radius*sin( (i-44)*PI*(angle/180.0));      
    stroke(100,140,i,50); 
    strokeWeight(1.5); 
    line(0,0,x,y);
    //text((String)entry.getKey(), x, y); 
    fill(0,100,(70-i)*9,80); 
    noStroke(); 
    ellipse(x,y,rad,rad);
    fill(255);
    textAlign(CENTER, CENTER);  
    text(entry.getKey().toString(), x, y);
  }
  popMatrix(); 
  textAlign(LEFT); 
  textFont(font1);   
  fill(30); 
  text("REZA ALI - MAT 259 - INFORMATION VISUALIZATION", 5, 13);
  text("EXERCISE 1", 5, 28);    
}

void keyPressed()
{
  if(key == '-'){
    maxVal = maxVal-50;
    if(maxVal <= 10) { 
        maxVal = 0; 
    }
  }
 if(key == '='){
    maxVal = maxVal+50;
    }
  if(key== '0'){
    num = num+1; 
  } 
}

public ArrayList loadTransactions()
{
  ArrayList transactions = new ArrayList();

  File[] fileArr = listFiles(dataPath(""));

  for (int fn = 0; fn < fileArr.length; fn++) 
  {
    File f = (File) fileArr[fn];    

    if (!f.getName().endsWith(".txt"))
    {
      continue;
    }

    println("loading file... \"" + f.getName() + "\"");
    String[] lines = loadStrings(f);
    for (int i = 0; i < lines.length; i++)
    {
      transactions.add(parseTransaction(lines[i])); 
    }
  }
  return transactions;
}


// This function returns all the files in a directory as an array of File objects
// This is useful if you want more info about the file
public File[] listFiles(String dir) {
  File file = new File(dir);
  if (file.isDirectory()) {
    File[] files = file.listFiles();
    return files;
  } 
  else {
    // If it's not a directory
    return null;
  }
}

public Transaction parseTransaction(String line)
{
  //String sections[] = split(line, ",");

  Transaction t = new Transaction();
   t.title = line;
  return t;
}








